#/usr/bin/perl -w

package GOGraph::Associate::Associate;

=head1 DESCRIPTION

  This class is really a bit dead at the moment, and isn't really used for
  anything, although historically it was quite cute.

=cut

use strict;
use Exporter;
use vars qw{@ISA};
use GO::AppHandle;
use GOGraph::Dotty::Dotty;
use GeneOntology::Association::AssociationHandle;
use Prints::PrintsHandle;


sub new{
  my $proto = shift;
  my $class = ref($proto) || $proto;
  my $params = shift;

  my $self = {};

  ## need to improve this...
  #my $go_handle = GO::AppHandle->connect(-dbname=>"go",-dbhost=>"localhost");
  my $go_handle = GO::AppHandle->connect(-dbname=>"go",-dbhost=>"sin.lbl.gov");
  my $prints_handle = Prints::PrintsHandle->new( {package=>"Sql"} );

  $self->{go_handle} = $go_handle;
  $self->{prints_handle} = $prints_handle;

  bless $self, $class;
  return $self;
}


## Given a finger print, get all associated sequences. From sequences
## get all associated gene ontology codes. Show the gene ontology
## codes. 
sub get_go_graph_from_fingerprint{
  my $self = shift;
  my $identifier = shift;
  my $prints_handle = $self->{prints_handle};
  my $go_handle = $self->{go_handle};
  my $fingerprint = $prints_handle->get_fingerprint_by_name
    ( $identifier );
  my $true_positives = $fingerprint->true_positives();

  my $association_handle;
  my @associations;

  foreach my $seq ( @$true_positives ){
    my $assocn = $association_handle->
      get_association_by_sequence_identifier( $seq->identifier() );
    push( @associations, @$assocn );
  }

  my $goterms = $self->get_go_terms_from_associations( \@associations );

  my $graph = $go_handle->get_graph_by_terms( $goterms, 0);
  my $graphviz = GOGraph::Dotty::Dotty::go_graph_to_graphviz( $graph );

  GOGraph::Dotty::Dotty::label_nodes_with_colour( $graphviz, $graph->focus_nodes(), "green" );
  GOGraph::Dotty::Dotty::label_nodes_with_colour
      ( $graphviz, $self->_get_curated_terms( \@associations ), "red" );
  return $graphviz;
}



sub get_go_graph_from_swissprot{
  my $self = shift;
  my $identifier = shift;
#  my $association_handle = $self->{association_handle};
  my $go_handle = $self->{go_handle};

#  my $associations = $association_handle->
#    get_association_by_sequence_identifier( $identifier );
#  my $goterms = $self->get_go_terms_from_associations( $associations );
  my $goterms = $go_handle->get_terms({'products'=>'$identifier'});
  my $gocuratedterms = $self->_get_curated_terms( $goterms );
  my $graph = $go_handle->get_graph_by_terms( $goterms, 0);
  my $graphviz = GOGraph::Dotty::Dotty::go_graph_to_graphviz( $graph );

  GOGraph::Dotty::Dotty::label_nodes_with_colour( $graphviz, $graph->focus_nodes(), "green" );
  GOGraph::Dotty::Dotty::label_nodes_with_colour
      ( $graphviz, $gocuratedterms, "red" );
  return $graphviz;
}


sub get_go_terms_from_associations{
  my $self = shift;
  my $associations = shift;
  my $go_handle = $self->{go_handle};
  my @goterms;

  foreach my $association ( @$associations ){
    my $goterm = $go_handle->get_term_by_acc
      ( $association->goid() );
    push( @goterms, $goterm );
  }
  return \@goterms;
}

sub _get_curated_terms{
  my $self = shift;
  my $goterms = shift;
  my @gocuratedterms;
  foreach my $term(@$goterms){
    my $association = $term->selected_association_list();
    if( $self->_best_evidence( $association ) > 0.1 ){
      push( @gocuratedterms, $term );
    }
  }
  return \@gocuratedterms;
}


sub _best_evidence{
  my $self = shift;
  my $association_list = shift;
  my $best_evidence = 0;
  my %probs = qw(IEA 0.1 NAS 0.3 NR  0.3 ISS 0.4
		 IMP 0.6 IGI 0.6 IPI 0.6 IDA 0.8
		 TAS 0.9 );

  foreach my $association (@$association_list){
    print "Assoc: $association\n";
    my $evidence_list = $association->evidence_list();
    foreach my $evidence (@$evidence_list){
      print "Evidence: $evidence\n";
      if( $probs{$evidence->code} > $best_evidence ){
       $best_evidence = $probs{$evidence->code};
        print "Best evidence is $best_evidence";
      }
    }
  }

  return $best_evidence;
}

1;
