package GOGraph::Crawl::AcceptNone;

=head1 NAME

  GOGraph::Crawl::AcceptNone

=head1 DESCRIPTION

  Accept no links at all. See GOGraph::Crawl::Accept and
  GOGraph::Crawl::CrawlToRoot for more details.

  Note that the CrawlToRoot class fakes links to the root node for
  any "orphan" node, and this class essentially turns every node
  into an orphan.

=head1 AUTHOR

  Phillip Lord (p.lord@russet.org.uk)

=head1 COPYRIGHT

  This code is copyright by the University of Manchester (2002)

=head1 LICENSE

  This module is free software; you can redistribute it or
  modify it under the same terms as Perl itself.

  If you use this software for published research, please
  check my website (http://www.russet.org.uk) for recent
  citation.

=cut

use strict;

sub new{
  my $proto = shift;
  my $class = ref($proto) || $proto;

  my $self = {};
  bless $self, $class;

  return $self;
}

sub accept{
  return 0;
}

sub name{
  return "norelationships";
}

1;
