#!/usr/bin/perl -w

package GOGraph::GOAppHandleFactory;

=head1 NAME

  GOGraph::GOAppHandleFactory

=head1 DESCRIPTION

  Factory for creating AppHandles, and database connections.  You will
  need to edit this file if the defaults are not good for you. Which
  they probably will not be. Make sure you do both the app handle, and
  the direct connection.

  I used to have a nice configuration mechanism for this, but it didn't
  seem to be worth the effort.

=cut

use GO::AppHandles::AppHandleCachingImpl;
# use Config::App::AppProperties;
use GO::AppHandle;
use DBI;


my $_factory;

sub go_apph{
  if( !defined( $_factory ) ){
    $_factory = _create_go_apph();
    ## The caching app handle is much much faster for most of the
    ## parts of this library, but sometimes returns the wrong results.
    ## Uncomment this at your peril

    ## In particular, for any of the similarity measures which use
    ## information about the evidence tags, uncommenting this MAY
    ## RESULT IN THE WRONG RESULTS BEING RETURNED. This is because
    ## they use the selected_association_list method, which means that
    ## you can not properly flyweight these terms.
    $_factory = GO::AppHandles::AppHandleCachingImpl->new
      ( $_factory );
  }
  return $_factory;
}


sub _create_go_apph{
  ## my $config = Config::App::AppProperties->get_instance();
  ## my $database = $properties->getProperty( "go.api.database.name" ) || "go";
  ## my $host = $properties->getProperty( "go.api.database.host" ) || "localhost";
  ## my $pass = $properties->getProperty( "go.api.database.password" );

  ## Edit these appropriately for your database.
  my $database = "go";
  my $host = "localhost";
  my $pass ="h0bbes";

  if( defined $pass ){
    return GO::AppHandle
      ->connect(-dbname=>$database,-dbhost=>$host,-dbauth=>$pass);
  }
  else{
    return GO::AppHandle
      ->connect(-dbname=>$database,-dbhost=>$host);
  }
}


sub go_dbi_connection{
  ## my $config = Config::App::AppProperties->new();
  ## my $properties = $config->load_config( "datasource.props" );

  ## Edit these appropriately for your database.
  my $go_dbi_database = "DBI:mysql:database=go;host=localhost";
  my $go_dbi_username = "phil";
  my $go_dbi_password = "h0bbes";

  return DBI->connect( $go_dbi_database, $go_dbi_username, $go_dbi_password );
}

1;
