#!/usr/bin/perl -w

package GOGraph::Gosst::ExtractResults;

use strict;
use DBI;



my $connection = DBI->connect( "dbi:mysql:database=gosst_results", "root", "" ) || die "Failed to connect $!";
my $extract_results_sth =
  $connection->prepare
  ( "select accn_two, similarity, accn_two_desc from compare where accn_one = ? and type_id = ? order by similarity" );
my $extract_ids_sth =
  $connection->prepare( "select * from constraint_type" );

my $constraints = {};

#prepare_extract();
#my $results = extract_results( "143E_HUMAN" );


#print "Complete\n";

sub prepare_extract{
  $extract_ids_sth->execute();
  while( my $row = $extract_ids_sth->fetchrow_arrayref() ){
    $constraints->{$row->[0]} = $row->[1];
  }
}

##
## Function returns an hash. Hash is keyed on constraint names,
## and valued on array refs, each of which contains an accession
## and a similiarity score
sub extract_results{
  my $accn = shift;

  my $results = {};
  foreach my $cons ( keys (%$constraints) ){
 #   print "Similarity for " . $constraints->{$cons} . "\n";
    my $res = [];
    $extract_results_sth->execute( $accn, $cons );
    while( my $result = $extract_results_sth->fetchrow_arrayref() ){
      push @$res, [ $result->[ 0 ], $result->[ 1 ], $result->[ 2 ] ];
  #    print $result->[ 0 ] . " " . $result->[ 1 ] . "\n";
    }
    $results->{$constraints->{$cons}} = $res;
  }
  return $results;
}
