#!/usr/bin/perl -w

use strict;

use GOGraph::Statistics::GOCompare;
use GOGraph::Similarity::Factory;
use GOGraph::Gosst::GosstDatabaseResultsHandler;
use GOGraph::GeneProduct::Collections::AllSwissprotCollection;

my $comparitors = [];

push @$comparitors, GOGraph::Similarity::Factory::resnick_aspect_function_good();
push @$comparitors, GOGraph::Similarity::Factory::resnick_aspect_process_good();
push @$comparitors, GOGraph::Similarity::Factory::resnick_aspect_component_good();

# push @$comparitors, GOGraph::Similarity::Factory::lin_constraint
#   ( GOGraph::Similarity::Factory::constraint_all_relation_function_terms_evidence_above_9() );
# push  @$comparitors, GOGraph::Similarity::Factory::lin_constraint
#    ( GOGraph::Similarity::Factory::constraint_all_relation_process_terms_evidence_above_9() );
# push  @$comparitors, GOGraph::Similarity::Factory::lin_constraint
#   ( GOGraph::Similarity::Factory::constraint_all_relation_component_terms_evidence_above_9() );

#push @$comparitors, GOGraph::Similarity::Factory::jiang_constraint
#  ( GOGraph::Similarity::Factory::constraint_all_relation_function_terms_evidence_above_9() );
#push  @$comparitors, GOGraph::Similarity::Factory::jiang_constraint
#  ( GOGraph::Similarity::Factory::constraint_all_relation_process_terms_evidence_above_9() );
#push  @$comparitors, GOGraph::Similarity::Factory::jiang_constraint
#  ( GOGraph::Similarity::Factory::constraint_all_relation_component_terms_evidence_above_9() );



my $printout = GOGraph::Gosst::GosstDatabaseResultsHandler->new;

my $goaspect = GOGraph::Statistics::GOCompare->new
  ( $comparitors, $printout );

$printout->prepare_database;


my $search_proteins = GOGraph::GeneProduct::Collections::AllSwissprotCollection->new->collection;

my @blah = @$search_proteins;
$#blah = 200;
$search_proteins = \@blah;
print "size is " . $#blah . "\n";

my $searches_complete = 0;
foreach my $outer_search ( @$search_proteins ){

  print "Searches Complete:- $searches_complete, working on $outer_search\n";
  $searches_complete++;
  my $start = time;
  foreach my $search ( @$search_proteins ){
    $goaspect->compare( $outer_search, $search );
  }

  $printout->commit_results;
  $printout->clear_results;
}

print "Complete\n";

