#!/usr/bin/perl -w

=head1 NAME

  plotblastall

=head1 DESCRIPTION

  This file works it way through swissprot. For each protein, it performs a blast,
  compares each hit for semantic and sequence similarity. 
=head1 AUTHOR

  Phillip Lord (p.lord@russet.org.uk)

=head1 COPYRIGHT

  This code is copyright by the University of Manchester (2002)

=head1 LICENSE

  This module is free software; you can redistribute it or
  modify it under the same terms as Perl itself.

  If you use this software for published research, please
  check my website (http://www.russet.org.uk) for recent
  citation.

=cut
use strict;

use GOGraph::Statistics::BlastDispatcher;
use GOGraph::Statistics::GOCompare;
use GOGraph::Similarity::Factory;
use GOGraph::Statistics::FileOutResults;


$| = 1;
my $comparitors =
  [ GOGraph::Similarity::Factory::resnick_aspect_process_good,
    GOGraph::Similarity::Factory::resnick_aspect_function_good,
    GOGraph::Similarity::Factory::resnick_aspect_component_good ];

##resnick_similarities_array_reference();


my $goaspect = GOGraph::Statistics::GOCompare->new
  ( $comparitors, GOGraph::Statistics::FileOutResults->new );
my $dispatcher = GOGraph::Statistics::BlastDispatcher->new
  ( $goaspect );



$dispatcher->straight_blast_hits();


