#!/usr/bin/perl -w

## NOT CURRENTLY FUNCTIONAL

use strict;

use GOGraph::Statistics::SwissprotPairDispatcher;
use GOGraph::Similarity::Factory;


$| = 1;


my $comparitors = {};

$comparitors->{"resnick"}
    = [
       GOGraph::Similarity::Factory::resnick_aspect_function_good(),
       GOGraph::Similarity::Factory::resnick_aspect_process_good(),
       GOGraph::Similarity::Factory::resnick_aspect_component_good()
      ];


$comparitors->{"jiang"}
   = [
      GOGraph::Similarity::Factory::jiang_constraint
      ( GOGraph::Similarity::Factory::constraint_all_relation_function_terms_evidence_above_9() ),
      GOGraph::Similarity::Factory::jiang_constraint
      ( GOGraph::Similarity::Factory::constraint_all_relation_process_terms_evidence_above_9() ),
      GOGraph::Similarity::Factory::jiang_constraint
      ( GOGraph::Similarity::Factory::constraint_all_relation_component_terms_evidence_above_9() )
     ];

$comparitors->{"lin"}
  = [
     GOGraph::Similarity::Factory::lin_constraint
     ( GOGraph::Similarity::Factory::constraint_all_relation_function_terms_evidence_above_9() ),
     GOGraph::Similarity::Factory::lin_constraint
     ( GOGraph::Similarity::Factory::constraint_all_relation_process_terms_evidence_above_9() ),
     GOGraph::Similarity::Factory::lin_constraint
     ( GOGraph::Similarity::Factory::constraint_all_relation_component_terms_evidence_above_9() )
    ];


my @pids;

my $comp = $ARGV[ 0 ];

#foreach my $comp ( qw( resnick lin jiang ) ){

  #if( my $pid = fork ){
  my $pid = 0;
  if( $pid ){
    ## parental...store pid so we can wait for it
    push @pids, $pid;
  }
  else{
    ## child process
    mkdir( $comp );
    chdir( $comp );
    my $comparitor = $comparitors->{$comp};
    my $dispatcher = GOGraph::Statistics::SwissprotPairDispatcher
      ->new( $comparitor, $comp );

    $dispatcher->pairwise_compare();
    print "$comp complete\n";
    exit();
  }
  sleep 10;
#}

#foreach my $pid ( @pids ){
#  waitpid( $pid, 0 );
#}


print "complete\n";
