#!/usr/bin/perl -w

package GOGraph::Similarity::InformationContent::Base::AcceptOnlyEvidence;

use strict;
## is this term accept or not?

=head2 accept

  Args - GO::Model::Term - is this term acceptable or not.
  Returns - true or false!

  Defines an interface for ensuring that a term is acceptable for
  Similarity testing.

=head1 AUTHOR

  Phillip Lord (p.lord@russet.org.uk)

=head1 COPYRIGHT

  This code is copyright by the University of Manchester (2002)

=head1 LICENSE

  This module is free software; you can redistribute it or
  modify it under the same terms as Perl itself.

  If you use this software for published research, please
  check my website (http://www.russet.org.uk) for recent
  citation.

=cut

sub new{
  my $proto = shift;
  my $class = ref($proto) || $proto;
  my $evidence = shift;

  my $self = {};
  $self->{evidence} = $evidence;

  bless $self, $class;
  return $self;
}

sub accept{
  my $self = shift;
  my $term = shift;

  ## this should select only those associations that we queried for in
  ## the first place.
  my $associations = $term->selected_association_list;

  foreach my $association ( @$associations ){
    my $evidence_list = $association->evidence_list;
    foreach my $evidence ( @$evidence_list ){
      if( $evidence->code( ) eq $self->{evidence}){
        return 1;
      }
    }
  }
  return 0;
}


sub name{
  my $self = shift;
  return "evidence_only" . $self->{evidence};
}

1;
