#!/usr/bin/perl

package GOGraph::Similarity::InformationContent::Base::CreateDB;

=head1 NAME

  GOGraph::Similarity::InformationContent::Base::CreateDB

=head1 SYNOPSIS

  er...just run it.

=head1 DESCRIPTION

  The script creates the information content database that is needed
  later. It's a little bit hard coded at the moment. You can always
  cut and paste the SQL out by hand into a mysql client.

=head1 AUTHOR

  Phillip Lord (p.lord@russet.org.uk)

=head1 COPYRIGHT

  This code is copyright by the University of Manchester (2002)

=head1 LICENSE

  This module is free software; you can redistribute it or
  modify it under the same terms as Perl itself.

  If you use this software for published research, please
  check my website (http://www.russet.org.uk) for recent
  citation.

=cut

use strict;
use DBI;

create_table( "informationcontent" );
exit( 0 );


sub create_table{

  my $database_name = shift || "informationcontent";

  my $create=<<SQL;
create table similarity
  ( id int,
    go_accn varchar(255),
    type_id int,
    occurences int )
SQL

  my $create_cons=<<SQL;
create table constraint_type
  ( id int,
    short_name varchar(255) )
SQL

  system( "mysqladmin drop $database_name" );
  system( "mysqladmin create $database_name" );

#  system( "dropdb $database_name" ); # || die "$!";
#  system( "createdb $database_name" );# || die "$!";


  my $connection = DBI->connect
    ( "dbi:mysql:database=$database_name", "root", "" );

  $connection->do( $create );
  $connection->do( $create_cons );

  $connection->disconnect;
}
