#!/usr/bin/perl -w

use strict;
use FileHandle;


## This script goes through the data generated by the
## plotsemanticcompare script. This generates three columns of data,
## which are function, process, and component scores. This scripts
## takes out all possible pairs of columns, and removes those where
## both of the columns has a -1.


my $fp = FileHandle->new( ">function-process.pair.dat" ) || die $!;
my $pc = FileHandle->new( ">process-component.pair.dat" ) || die $!;
my $fc = FileHandle->new( ">function-component.pair.dat" ) || die $!;


while(<>){
  my( $f, $p, $c ) = split;
  write_out( $fp, $f, $p );
  write_out( $pc, $p, $c );
  write_out( $fc, $f, $c );
}



$fp->close;
$pc->close;
$fc->close;


sub write_out{
  my $fh = shift;
  my $x = shift;
  my $y = shift;

  if( defined $x && defined $y ){
    unless( $x < 0 || $y < 0 ){
      $fh->print( "$x $y\n" );
    }
  }
}
