#!/usr/bin/perl -w

package GOGraph::Statistics::CompareOutput;

=head1 NAME

  GOGraph::Statistics::CompareOutput

=head1 SYNOPSIS

=cut
use FileHandle;
use Carp;

sub new{
  my $proto = shift;
  my $class = ref( $proto ) || $proto;

  my $comparitor_name = shift;

  my $self = {};
  bless $self, $class;

  $self->_initialize( $comparitor_name );
  return $self;
}


sub _initialize{
  my $self = shift;
  my $comparitor_name = shift;

  if( defined $comparitor_name ){
    my $filehandle = FileHandle->new( "> blast_"
                                      . $comparitor_name . ".dat" ) || croak $!;
    $filehandle->autoflush();
    $self->{filehandle} = $filehandle;
  }
}


sub process_result{
  my $self = shift;
  my $sequence_similarity = shift;
  my $semantic_similarity = shift;

  if( $semantic_similarity >= 0 ){
    $self->{filehandle}->print( "$sequence_similarity $semantic_similarity\n" );
  }
}


sub factory{
  
}

1;
