#!/usr/bin/perl -w

package GOGraph::Statistics::OutputSemSimAbove;

use FileHandle;
use Carp;
use Exporter;
use strict;


use vars qw(@ISA);
use base qw(GOGraph::Statistics::CompareOutput Exporter);


my $cutoff = 0;

sub _initialize{
  my $self = shift;
  my $comparitor_name = shift;

  if( defined $comparitor_name ){
    my $filehandle = FileHandle->new( ">> outlier_" . $comparitor_name . ".dat" ) || croak $!;

    $filehandle->autoflush();
    $self->{filehandle} = $filehandle;
  }
}


sub process_result{
  my $self = shift;
  my $sequence_similarity = shift;
  my $semantic_similarity = shift;

  my $acc = shift;
  my $match_acc = shift;

  if( $semantic_similarity > $GOGraph::Statistics::OutputSemSimAbove::cutoff ){
    $self->{filehandle}->print( "$acc $match_acc $sequence_similarity $semantic_similarity\n" );
  }
}

1;
