#!/usr/bin/perl -w

package GOGraph::Statistics::OutputSequenceSimAbove;

use FileHandle;
use Carp;
use Exporter;
use strict;


use vars qw(@ISA);
use base qw(GOGraph::Statistics::CompareOutput Exporter);

my $cutoff = 7;

sub _initialize{
  my $self = shift;
  my $comparitor_name = shift;

  if( defined $comparitor_name ){
    my $filehandle = FileHandle->new( "> sequence_outlier_" . $comparitor_name . ".dat" ) || croak $!;

    $filehandle->autoflush();
    $self->{filehandle} = $filehandle;
  }
}


sub process_result{
  my $self = shift;
  my $sequence_similarity = shift;
  my $semantic_similarity = shift;

  my $acc = shift;
  my $match_acc = shift;

  if( $sequence_similarity > $cutoff && $semantic_similarity >= 0 ){
    $self->{filehandle}->print( "$acc $match_acc $sequence_similarity $semantic_similarity\n" );
  }
}

1;
