#!/usr/bin/perl -w

=head1 NAME

  CharacteriseRelationships

=head1 DESCRIPTIONS

  Counts the number of different relationships, for
  the different aspects of GO.

=cut

use strict;

use GOGraph::GOAppHandleFactory;
use GOGraph::Statistics::Scripts::CharacteriseRelationships;
use GO::AppHandle;#
use Config::App::AppProperties;



my $apph = GOGraph::GOAppHandleFactory::go_apph();

print "Characterise Relationship\n";

my $root_terms = $apph->get_ontology_root_terms();
push @$root_terms, $apph->get_root_term;


foreach my $start_term ( @$root_terms ){
  my $results =
    GOGraph::Statistics::Scripts::CharacteriseRelationships::characterise_relationships
        ( $start_term );

  print "For the root term " . $start_term->name . "\n";
  use Dumpvalue;
  Dumpvalue->new()->dumpValue( $results );
}
