#!/usr/bin/perl -w

use strict;
use Test;
use lib "t", "lib";

use factory;

use GOGraph::Similarity::Factory;
use GOGraph::GeneProduct::SemanticSimilarity::PairwiseAverageSimilarity;
use GOGraph::GeneProduct::SemanticSimilarity::MaximumPairwiseSimilarity;

BEGIN{ plan tests => 4 }

my $combined_similarity_pairwise
  = GOGraph::GeneProduct::SemanticSimilarity::PairwiseAverageSimilarity
  ->new( GOGraph::Similarity::Factory::resnick_aspect_function_good() );

my $combined_similarity_maximum
  = GOGraph::GeneProduct::SemanticSimilarity::MaximumPairwiseSimilarity
  ->new( GOGraph::Similarity::Factory::resnick_aspect_function_good() );

ok( 1 );

## fetch some terms. The protein here is more or less irrelevant,
## although it will affect the return values which are tested below.
my $go_terms = go_apph()->get_terms({'products'=>'opsr_human'});

my $pairwise = $combined_similarity_pairwise->semantic_similarity
  ( $go_terms, $go_terms );

my $max = $combined_similarity_maximum->semantic_similarity
  ( $go_terms, $go_terms );

ok( 1 );

print "Pairwise is $pairwise, Max is $max\n";


## sanity checking on return values. These are dependant on the
## protein defined above, which was opsr_human when I wrote this. The
## return value may change over time, with future releases of GO.
ok( $pairwise > 6 && $pairwise < 10 );
ok( $max > 6 && $max < 10 );

