#!/usr/bin/perl -w

use strict;
use Test;
use lib "t", "lib";

use GOGraph::GeneProduct::SemanticSimilarity::PairwiseAverageSimilarity;
use GOGraph::GeneProduct::SemanticSimilarity::GeneProductSimilarity;
use GOGraph::Similarity::Factory;


BEGIN{ plan tests => 4 }

## a protein to measure the similarity off. We can use a self/self
## quite happily. Changing this protein will require alternation to
## the test below, which tests the return value.
my $protein = "OPSR_HUMAN";

## to measure similarity of a protein we need to compare more several
## terms, so need to combine their similarity.
my $combined_similarity =
  GOGraph::GeneProduct::SemanticSimilarity::PairwiseAverageSimilarity
  ->new( GOGraph::Similarity::Factory::resnick_aspect_function() );

ok( 1 );

## and we need to be able to convert between identifiers and terms.
my $swissprot_similarity =
  GOGraph::GeneProduct::SemanticSimilarity::GeneProductSimilarity
  ->new( $combined_similarity );


ok( 1 );

my $similarity = $swissprot_similarity->semantic_similarity
  ( $protein, $protein );

print "Similarity is $similarity\n";

## this check is specific to the protein used to test for. This value
## was originally set for OPSR_HUMAN, and even then it could change
ok( $similarity > 4 );
ok( $similarity < 12 );




